#pragma hdrstop
#include "Vertex.h"

int CVertexList::AddVertex(CVertex& v)
{
	SetVertex(count,v);
	count++;
	if (count>=arraySize)
	{
		D3DVERTEX *newList=new D3DVERTEX[arraySize+VERT_BLOCK_SIZE];
		memcpy(newList,list,arraySize*sizeof(D3DVERTEX));
		delete[] list;
		list=newList;
		arraySize+=VERT_BLOCK_SIZE;		
	}
	return count-1;
}

int CTLVertexList::AddVertex(CTLVertex& v)
{
	SetVertex(count,v);
	count++;
	if (count>=arraySize)
	{
		D3DTLVERTEX *newList=new D3DTLVERTEX[arraySize+VERT_BLOCK_SIZE];
		memcpy(newList,list,arraySize*sizeof(D3DTLVERTEX));
		delete[] list;
		list=newList;
		arraySize+=VERT_BLOCK_SIZE;		
	}
	return count-1;
}

int CIndexList::AddIndex(WORD n)
{
	SetIndex(count,n);
	count++;
	if (count>=arraySize)
	{
		WORD *newList=new WORD[arraySize+VERT_BLOCK_SIZE];
		memcpy(newList,list,arraySize*sizeof(WORD));
		delete[] list;
		list=newList;
		arraySize+=VERT_BLOCK_SIZE;
	}
	return count-1;
}

void CVertexList::Reflect(float waterLevel)
{
	for (int i=0;i<count;i++)
		list[i].y=waterLevel*2.0-list[i].y;
}

void CLVertexList::Reflect(float waterLevel)
{
	for (int i=0;i<count;i++)
		list[i].y=waterLevel*2.0-list[i].y;
}
