#ifndef __DIRECTINPUT_H__
#define __DIRECTINPUT_H__

#include <windows.h>
#include <dinput.h>

#define DINPUT_ALL 0
#define DINPUT_MOUSE 1
#define DINPUT_JOYSTICK 2

#define MB_DOWN 0
#define MB_UP 4

class CDirectInput
{
	HWND hWnd;
	HINSTANCE hInst;
	LPDIRECTINPUT lpDI;
	IDirectInputDevice2 *lpMouse;
	IDirectInputDevice2 *lpStick;
    int init;
public:
	CDirectInput(HINSTANCE inst,HWND wnd);
	~CDirectInput();
    int Initialized();
	void Acquire(int device=DINPUT_ALL);
	void Unacquire(int device=DINPUT_ALL);
	void GetInput(int device,int axis[4],int button[8]);
};

#endif
